package outils;

public class ListeChainee<Type> implements Liste<Type> {
	private class ElementDeListe {
		public Type contenu;
		public ElementDeListe suivant, precedent;
		public ElementDeListe(Type element) {
			contenu = element;
			suivant = null;
			precedent = null;
		}
	}
	private class ParcoursALEndroit implements Parcours<Type> {
		private ElementDeListe courant;
		public ParcoursALEndroit() {
			courant = premier;
		}
		public boolean encore() {
			return courant != null;
		}
		public Type elementCourant() {
			return courant.contenu;
		}
		public void suite() {
			courant = courant.suivant;
		}
	}
	private ElementDeListe premier, dernier;
	private int nbElem;
	public ListeChainee() {
		premier = null;
		dernier = null;
		nbElem = 0;
	}	
	public boolean estVide() {
		return nbElem == 0;
	}
	public int nombreDElements() {
		return nbElem;
	}
	public void ajoute(Type element) {
        ElementDeListe nouveau = new ElementDeListe(element);
        if (premier == null) {
            premier = nouveau;
        } else {
            dernier.suivant = nouveau;
            nouveau.precedent = dernier;
        }
        dernier = nouveau;
        nbElem++;
	}
    private void supprimeElementDeListe(ElementDeListe aSuppr) {
        if (aSuppr.precedent != null) {
            aSuppr.precedent.suivant = aSuppr.suivant;
        } else {
            premier = aSuppr.suivant;
        }
        if (aSuppr.suivant != null) {
            aSuppr.suivant.precedent = aSuppr.precedent;
        } else {
            dernier = aSuppr.precedent;
        }
        nbElem--;
        aSuppr.precedent = null;
        aSuppr.suivant = null;
    }
	public void retire(int index) {
        ElementDeListe courant = premier;
        for (int i = 0; i < index; i++) {
            courant = courant.suivant;
        }
        supprimeElementDeListe(courant);
	}
	public Type element(int index) {
        ElementDeListe courant = premier;
//      if(index < 0 || index >= nbElem) return null;
        while(/* courant != null && */index > 0) {
System.out.print(".");
            courant = courant.suivant;
            index--;
        }
        return courant.contenu;
	}
	public Parcours<Type> parcours() {
		return new ParcoursALEndroit();
	}
}
